<div class="game-search-modal">
  <AdvancedModal>
    <div class="game-search-modal-content">
      <div class="game-search">
        <div class="header">
          <input type="text"
                 class="searchbox"
                 bind:value="gameQuery"
                 placeholder="Search for Games" />
        </div>
        <div class="game-list">
          {#each games as game (game.id)}
          <div class="game-listing" on:click="setGame(game)">
            <div class="game-icon"
                 style={`background-image: url(${iconURL(game)})`} />
            <div class="game-data">
              <h2 class="game-name">
                {game.name}
              </h2>
              <p class="game-description">
                {game.description}
              </p>
            </div>
          </div>
        {/each}
        </div>
        <div class="load-more-games" on:click="loadMore(gameQuery, games)">
          More!!
        </div>
      </div>
    </div>
  </AdvancedModal>
</div>

<script>
  import RestClient from "../../js/RestClient";
  import env from "../../js/constants";
  
  export default {
    data() {
      return {
        games: [],
        gameQuery: ""
      };
    },
    components: {
      AdvancedModal: "./AdvancedModal.svelte"
    },
    helpers: {
      iconURL(game) {
        return `${env.API_BASE}/games/${game.id}/assets/icon`;
      }
    },
    methods: {
      setGame(game) {
        this.fire("modalEvent", game);
        this.store.set({modal: undefined});
      },
      async searchGames(query) {
        const games = await RestClient.get(
          `/games/search?q=${encodeURIComponent(query)}`
        );
        this.set({games});
      },
      async loadMore(query, games) {
        const url = `/games/search?q=${encodeURIComponent(query)}&after=${
          games[games.length - 1].id
        }`;
        const newGames = await RestClient.get(url);
        this.set({
          games: games.concat(newGames)
        });
      }
    },
    onstate({current, changed}) {
      if (changed.gameQuery) {
        this.searchGames(current.gameQuery);
      }
    }
  };
</script>

<style>
  .header {
    border-bottom: 2px solid #222;
    height: 2em;
    padding-bottom: 0.25em;
  }

  .game-search-modal-content {
    display: flex;
    flex-direction: column;
  }

  .game-listing {
    cursor: pointer;
    background: #222;
    margin: 0.25em;
    border-radius: 5px;
  }

  .game-list {
    display: grid;
    grid-template-columns: 50% 50%;
    overflow: auto;
  }

  .searchbox {
    background: #222;
    border: none;
    border-radius: 1em;
    color: #fff;
    width: calc(100% - 1em);
    padding: 0.5em;
  }

  .game-name {
    margin: 0;
    font-size: 1.25em;
  }
  .game-data {
    border-top: #222 solid 1px;
    margin: 0.25em 0.5em;
    margin-bottom: 0.5em;
  }

  .game-icon {
    height: 8em;
    background-color: #151515;
    background-position: center;
    background-size: cover;
    background-repeat: no-repeat;
  }

  .game-description {
    margin: 0;
    margin-top: 0.25em;
  }
</style>
